Bug 1419271 - Review Request: leatherman - A collection of C++ and CMake utility libraries
Summary: Review Request: leatherman - A collection of C++ and CMake utility libraries
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: James Hogarth
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1502584
Blocks: 1223593 RDO-OCATA 1506504
TreeView+ depends on / blocked
 
Reported: 2017-02-04 15:19 UTC by Haïkel Guémar
Modified: 2017-10-31 10:28 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-10-31 10:28:51 UTC
Type: ---
james.hogarth: fedora-review+


Attachments (Terms of Use)
licensecheck output (10.84 KB, text/plain)
2017-02-16 09:35 UTC, Javier Peña
no flags Details

Description Haïkel Guémar 2017-02-04 15:19:26 UTC
Spec URL: https://hguemar.fedorapeople.org/reviews/leatherman.spec
SRPM URL: https://hguemar.fedorapeople.org/reviews/leatherman-0.10.2-1.fc25.src.rpm
Description: A collection of C++ and CMake utility libraries
Fedora Account System Username: hguemar

Comment 1 Javier Peña 2017-02-16 09:34:35 UTC
Hi Haïkel,

I have found the following issues:

- There seems to be more more than one license in the code (see attached licensecheck.txt file), we should reflect that in the spec

- The broad wildcard in the -devel subpackage for %{_includedir}/* makes it own /usr/include/boost, which is owned by boost-devel

- The -devel subpackage includes a python script, should it then Require python?

Comment 2 Javier Peña 2017-02-16 09:35:03 UTC
Created attachment 1250815 [details]
licensecheck output

Comment 3 James Hogarth 2017-08-31 08:50:43 UTC
Hi Haïkel,

Are you still going to be able to drive this forward?

If not I'll take it over as it's a blocker to updating facter.

Regards,

James

Comment 4 Haïkel Guémar 2017-10-03 14:11:19 UTC
I'm still working on this but unbundling is far from trivial.

Comment 5 James Hogarth 2017-10-03 14:23:13 UTC
You'll be pleased to know I'm nearly done then - let's join forces to complete it :)

I'm just about to submit boost-nowide for review - if you want to take that and do the magic on it?

The rapidjson can't be unbundled yet due to versioning issues (this is being worked on upstream though to update the version included to the current version) but seeing how that is linked and the FPC decision a few weeks ago that's acceptable... and catch is only used in testing so that's fine.

Once boost-nowide is in place and this is building against it then it will be fine to go through.

Comment 6 James Hogarth 2017-10-16 09:44:41 UTC
Marking this blocked on the boost-nowide module as that's required to be unbundled for this review to complete.

Comment 7 James Hogarth 2017-10-26 13:48:15 UTC
The boost module is now available.

Are you okay to push this to the finish line?

Comment 8 Haïkel Guémar 2017-10-29 15:10:06 UTC
Spec URL: https://hguemar.fedorapeople.org/reviews/leatherman.spec
SRPM URL: https://hguemar.fedorapeople.org/reviews/leatherman-1.3.0-3.fc27.src.rpm

I merged your spec, I only kept compatibility with CentOS SIGs repo which have a newer boost159-devel, but diff is kept to a minimal by using a %boost_version macro.

Comment 9 James Hogarth 2017-10-30 09:40:38 UTC
Cool - I'll take over this review then :)

Comment 10 James Hogarth 2017-10-30 10:32:35 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "BSL (v1.0)", "ISC", "Unknown or generated",
     "BSD (3 clause)". 176 files have unknown license. Detailed output of
     licensecheck in /home/james/workspace/fedora-
     scm/1419271-leatherman/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package does not own files or directories owned by other packages.
     Note:  <SNIP> # false negative in f-r due to debug package changes
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     leatherman-debuginfo , leatherman-debugsource
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: leatherman-1.3.0-3.fc28.x86_64.rpm
          leatherman-devel-1.3.0-3.fc28.x86_64.rpm
          leatherman-debuginfo-1.3.0-3.fc28.x86_64.rpm
          leatherman-debugsource-1.3.0-3.fc28.x86_64.rpm
          leatherman-1.3.0-3.fc28.src.rpm
leatherman.x86_64: W: no-documentation
leatherman-devel.x86_64: W: only-non-binary-in-usr-lib
leatherman-devel.x86_64: W: no-documentation
leatherman-devel.x86_64: E: wrong-script-interpreter /usr/lib64/cmake/leatherman/scripts/cpplint.py /usr/bin/env python
leatherman-devel.x86_64: E: non-executable-script /usr/lib64/cmake/leatherman/scripts/cpplint.py 644 /usr/bin/env python
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_curl.so leatherman_curl.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_dynamic_library.so leatherman_dynamic_library.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_execution.so leatherman_execution.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_file_util.so leatherman_file_util.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_json_container.so leatherman_json_container.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_locale.so leatherman_locale.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_logging.so leatherman_logging.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_ruby.so leatherman_ruby.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_util.so leatherman_util.so.1.3.0
leatherman-debuginfo.x86_64: E: useless-provides debuginfo(build-id)
leatherman-debugsource.x86_64: W: no-documentation
leatherman.src:67: W: mixed-use-of-spaces-and-tabs (spaces: line 8, tab: line 67)
5 packages and 0 specfiles checked; 3 errors, 14 warnings.




Rpmlint (debuginfo)
-------------------
Checking: leatherman-debuginfo-1.3.0-3.fc28.x86_64.rpm
leatherman-debuginfo.x86_64: E: useless-provides debuginfo(build-id)
1 packages and 0 specfiles checked; 1 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
leatherman-debugsource.x86_64: W: invalid-url URL: https://github.com/puppetlabs/leatherman <urlopen error [Errno -2] Name or service not known>
leatherman-debugsource.x86_64: W: no-documentation
leatherman-debuginfo.x86_64: W: invalid-url URL: https://github.com/puppetlabs/leatherman <urlopen error [Errno -2] Name or service not known>
leatherman-debuginfo.x86_64: E: useless-provides debuginfo(build-id)
leatherman-devel.x86_64: W: invalid-url URL: https://github.com/puppetlabs/leatherman <urlopen error [Errno -2] Name or service not known>
leatherman-devel.x86_64: W: only-non-binary-in-usr-lib
leatherman-devel.x86_64: W: no-documentation
leatherman-devel.x86_64: E: wrong-script-interpreter /usr/lib64/cmake/leatherman/scripts/cpplint.py /usr/bin/env python
leatherman-devel.x86_64: E: non-executable-script /usr/lib64/cmake/leatherman/scripts/cpplint.py 644 /usr/bin/env python
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_curl.so leatherman_curl.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_dynamic_library.so leatherman_dynamic_library.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_execution.so leatherman_execution.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_file_util.so leatherman_file_util.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_json_container.so leatherman_json_container.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_locale.so leatherman_locale.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_logging.so leatherman_logging.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_ruby.so leatherman_ruby.so.1.3.0
leatherman-devel.x86_64: W: dangling-relative-symlink /usr/lib64/leatherman_util.so leatherman_util.so.1.3.0
leatherman.x86_64: W: invalid-url URL: https://github.com/puppetlabs/leatherman <urlopen error [Errno -2] Name or service not known>
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_curl.so.1.3.0 /lib64/leatherman_util.so.1.3.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_curl.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_dynamic_library.so.1.3.0 /lib64/leatherman_util.so.1.3.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_dynamic_library.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_execution.so.1.3.0 /lib64/leatherman_file_util.so.1.3.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_execution.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_file_util.so.1.3.0 /lib64/leatherman_util.so.1.3.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_file_util.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_json_container.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_locale.so.1.3.0 /lib64/libboost_system.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_locale.so.1.3.0 /lib64/leatherman_util.so.1.3.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_locale.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libboost_log_setup.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libboost_thread.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libboost_date_time.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libboost_filesystem.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libboost_chrono.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libboost_atomic.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/librt.so.1
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_logging.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_ruby.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_util.so.1.3.0 /lib64/libboost_date_time.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_util.so.1.3.0 /lib64/libboost_chrono.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_util.so.1.3.0 /lib64/libboost_system.so.1.64.0
leatherman.x86_64: W: unused-direct-shlib-dependency /usr/lib64/leatherman_util.so.1.3.0 /lib64/libm.so.6
leatherman.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 3 errors, 42 warnings.



Requires
--------
leatherman-debugsource (rpmlib, GLIBC filtered):

leatherman-debuginfo (rpmlib, GLIBC filtered):

leatherman-devel (rpmlib, GLIBC filtered):
    boost-nowide-devel
    cmake-filesystem(x86-64)
    leatherman(x86-64)

leatherman (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libboost_atomic.so.1.64.0()(64bit)
    libboost_chrono.so.1.64.0()(64bit)
    libboost_date_time.so.1.64.0()(64bit)
    libboost_filesystem.so.1.64.0()(64bit)
    libboost_locale.so.1.64.0()(64bit)
    libboost_log.so.1.64.0()(64bit)
    libboost_log_setup.so.1.64.0()(64bit)
    libboost_regex.so.1.64.0()(64bit)
    libboost_system.so.1.64.0()(64bit)
    libboost_thread.so.1.64.0()(64bit)
    libc.so.6()(64bit)
    libcurl.so.4()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
leatherman-debugsource:
    leatherman-debugsource
    leatherman-debugsource(x86-64)

leatherman-debuginfo:
    debuginfo(build-id)
    leatherman-debuginfo
    leatherman-debuginfo(x86-64)

leatherman-devel:
    cmake(Leatherman)
    leatherman-devel
    leatherman-devel(x86-64)

leatherman:
    leatherman
    leatherman(x86-64)



Source checksums
----------------
https://github.com/puppetlabs/leatherman/archive/1.3.0.tar.gz#/leatherman-1.3.0.tar.gz :
  CHECKSUM(SHA256) this package     : 282bc54ca28e8269a392bbda423b940177a5925246ab961c7a5c338046b51ba0
  CHECKSUM(SHA256) upstream package : 282bc54ca28e8269a392bbda423b940177a5925246ab961c7a5c338046b51ba0


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1419271
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

== Summary ==

It was pointed out to me in the boost-nowide review that %__make should generally be replaced by %make_build unless there is an issue with multithreaded builds. On import please test it with %make_build instead of %__make and if there are any build issues please add a comment to the spec file explaining.

There's something odd with the autoreq/autoprov and the leatherman libraries. I don't consider it a blocker but it is a little odd that the libs are not in the provides, and a package built against this doesn't automatically get the libs correctly.

Would be interesting to track down why ... but it's food for thought with dependent packages having a simple workaround of a specified requires for the time being.

On import please replace the tabs with spaces for consistency.

Since there are no significant issues this package is APPROVED with the caveat that the tabs are cleaned up on import and that %make_build is tested.


Note You need to log in before you can comment on or make changes to this bug.